unit UnitKugelzentrmain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, ToolWin, ComCtrls,math, ExtCtrls, ImgList,UnitHelp,
  Menus, System.ImageList;

const RhoG=200/Pi;

type
   TPunkt=Record
    PktNr:String;
    X,Y,Z,v:Double;
  end;
  TKoord=record
    NR,Code,Bem:String;
    Y,X,Z:Double;
  end;
  TSatzTyp=(Standpunkt,Zielpunkt,Kommentar);

  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    Label2: TLabel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    EditEindat: TEdit;
    StatusBar1: TStatusBar;
    ToolBar1: TToolBar;
    Memo1: TMemo;
    Label1: TLabel;
    TabSheet3: TTabSheet;
    Label3: TLabel;
    EditAusdat: TEdit;
    ToolButtonRechne: TToolButton;
    ToolButtonEnde: TToolButton;
    ImageList1: TImageList;
    TabSheet4: TTabSheet;
    Label4: TLabel;
    EditKoorDat: TEdit;
    ToolButtonHelp: TToolButton;
    RichEditKoo: TRichEdit;
    RichEditMessdat: TRichEdit;
    PopupMenuRichedit: TPopupMenu;
    Rckgngig1: TMenuItem;
    Ausschneiden1: TMenuItem;
    Einfgen1: TMenuItem;
    Lschen1: TMenuItem;
    Allemarkieren1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    Ausschneiden2: TMenuItem;
    procedure PageControl1Change(Sender: TObject);
    procedure PopupMenuKooPopup(Sender: TObject);
    procedure Rckgngig1Click(Sender: TObject);
    procedure Allemarkieren1Click(Sender: TObject);
    procedure Lschen1Click(Sender: TObject);
    procedure Einfgen1Click(Sender: TObject);
    procedure Ausschneiden2Click(Sender: TObject);
    procedure Ausschneiden1Click(Sender: TObject);
    procedure ToolButtonHelpClick(Sender: TObject);
    procedure ToolButtonEndeClick(Sender: TObject);
    procedure ToolButtonRechneClick(Sender: TObject);
    procedure EditKoorDatDblClick(Sender: TObject);
    procedure EditEindatDblClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Markiere(var AktEdit:TRichEdit;s:string;Farbe:Tcolor;Stil:TfontStyles);
    procedure MarkiereZeile(var AktEdit:TRichEdit;row:integer;Farbe:Tcolor;Stil:TfontStyles);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  P:Array of Tpunkt;
  PKoo:Array of TKoord;
  Sl:TStringList;
  Editor:TRichEdit;
implementation


{$R *.dfm}

procedure TForm1.Markiere(var AktEdit:TRichEdit;s:string;Farbe:Tcolor;Stil:TfontStyles);
Var k: integer;
    Foundpos: integer;
    OldCaretPos: TPoint;
begin
 OldCaretPos := AktEdit.CaretPos;
 For k := 0 to AktEdit.Lines.Count do
 begin
  Foundpos := AktEdit.FindText(s, 0, Length(AktEdit.Text), []);
  While foundpos <> -1 do
  begin
    AktEdit.selstart := Foundpos;
    AktEdit.SelLength := Length(s);
    AktEdit.SelAttributes.Style := [fsBold];
    AktEdit.SelAttributes.color := clRed;
    AktEdit.selstart := Foundpos+Length(s)+1;
    AktEdit.SelLength := 0;
    AktEdit.SelAttributes.Style := [];
    AktEdit.SelAttributes.color := clBlack;
    Foundpos := AktEdit.FindText(s, AktEdit.SelStart+1, Length(AktEdit.Text), []);
  end;
 end;
 AktEdit.CaretPos := OldCaretPos;
end;

procedure TForm1.MarkiereZeile(var AktEdit:TRichEdit;row:integer;Farbe:Tcolor;Stil:TfontStyles);
Var k: integer;
    Foundpos: integer;
    OldCaretPos: TPoint;
begin
 OldCaretPos := AktEdit.CaretPos;
 For k := 0 to AktEdit.Lines.Count do
 begin
  Foundpos := AktEdit.FindText(AktEdit.Lines[row], 0, Length(AktEdit.Text), []);
  While foundpos <> -1 do
  begin
    AktEdit.selstart := Foundpos;
    AktEdit.SelLength := Length(AktEdit.Lines[row]);
    AktEdit.SelAttributes.Style := Stil;
    AktEdit.SelAttributes.color := Farbe;
    AktEdit.selstart := Foundpos+Length(AktEdit.Lines[row])+1;
    AktEdit.SelLength := 0;
    AktEdit.SelAttributes.Style := [];
    AktEdit.SelAttributes.color := clBlack;
    Foundpos := AktEdit.FindText(AktEdit.Lines[row], AktEdit.SelStart+1, Length(AktEdit.Text), []);
  end;
 end;
 AktEdit.CaretPos := OldCaretPos;
end;


procedure TForm1.PageControl1Change(Sender: TObject);
begin
  case PageControl1.TabIndex of
  2:Editor:=RichEditMessdat;
  3:Editor:=RicheditKoo;
  end;
end;

procedure TForm1.PopupMenuKooPopup(Sender: TObject);
begin
end;

{$H+}
function GetVersionInfos(filename:String):string;
var iSize    : Integer;
    data     : Pointer;
    dw       : DWord;
    FileInfo : PVSFixedFileInfo;
begin
  Result      := '?';
  iSize := GetFileVersionInfoSize(PChar(filename),dw);
  if iSize >0 then begin
    GetMem(data,iSize);
    if GetFileVersionInfo(PChar(filename),0,iSize,data) then
      if VerQueryValue(data,'\',Pointer(FileInfo),dw) then
        result := format('%d.%d.%d.%d',[(FileInfo^.dwFileVersionMS shr 16),(FileInfo^.dwFileVersionMS and $FFFF),(FileInfo^.dwFileVersionLS shr 16),(FileInfo^.dwFileVersionLS and $FFFF)]);
    FreeMem(data,iSize);
  end;
end;
{$H-}

function GetStr(var s:String):String;
var i:Integer;
begin
  Result:='';
  While (length(s)>0) and (s[1]=' ') do delete(s,1,1);
  i:=pos(' ',s);
  if i>0 then
  begin
    Result:=copy(s,1,i-1);
    delete(s,1,i-1);
    s:=Trim(s);//While (length(s)>0) and (s[1]=' ') do delete(s,1,1);
  end
  else
  begin
    Result:=s;
    s:='';
  end;
end;

function GetFloat(var Satz:String):Real;
var i:integer;
    s:string;
begin
  S:='';
  While (length(satz)>0) and (Satz[1]=' ') do delete(satz,1,1);
  i:=pos(' ',Satz);
  if i>0 then
  begin
    s:=copy(satz,1,i-1);
    delete(satz,1,i-1);
    While (length(satz)>0) and (Satz[1]=' ') do delete(satz,1,1);
  end
  else
  begin
    if satz>'' then s:=Satz;
    satz:='';
  end;

  i:=Pos(',',S);
  if i>0 then
  begin
   S[i]:='.';
  end;

  try
   Result:=StrToFloat(s);
  except
    on EConvertError do
    begin
      Showmessage('Fehler: '+s+' ist kein gltiger Real Wert.');
      Result:=0;
    end;
  end;

end;

function GetInt(var Satz:String):Integer;
var i:integer;
    s:string;
begin
  S:='';
  While (length(satz)>0) and (Satz[1]=' ') do delete(satz,1,1);
  i:=pos(' ',Satz);
  if i>0 then
  begin
    s:=copy(satz,1,i-1);
    delete(satz,1,i-1);
    While (length(satz)>0) and (Satz[1]=' ') do delete(satz,1,1);
  end
  else
  begin
    if satz>'' then s:=Satz;
    satz:='';
  end;

  try
   Result:=StrToInt(s);
  except
    on EConvertError do
    begin
      Showmessage('Fehler: '+s+' ist kein gltiger Integer Wert.');
      Result:=0;
    end;
  end;

end;

function sgn(x:real):integer;
begin
  sgn:=0;
  if x<0 then sgn:=-1
  else if x>0 then sgn:=1;
end;

Procedure RIWI(dy,DX : Double;var S,T:Double);
Begin
  If DX = 0 Then T := sgn(dy)*Pi/2
  Else T := ArcTan(dy/DX);
  If DX < 0 Then T := T+Pi;
  If T < 0 Then T := T+Pi+Pi;
  S := Sqrt(dy*dy+DX*DX);
  If (DX = 0) And (dy = 0) Then T := 0;
End;

procedure LiesKoordDat(name:String);
var f:textfile;
    s:string;
begin
  if FileExists(name) then
  begin
    assignfile(f,name);
    Reset(f);
    setlength(PKoo,0);
    while not eof(f) do
    begin
      Readln(f,s);
      s:=trim(s);
      If copy(s,1,1)<>'*' then
      begin
        setlength(PKoo,length(Pkoo)+1);
        PKoo[high(Pkoo)].NR:=getStr(s);
        PKoo[high(Pkoo)].Y:=getFloat(s);
        PKoo[high(Pkoo)].X:=getFloat(s);
        PKoo[high(Pkoo)].Z:=getFloat(s);
        PKoo[high(Pkoo)].Code:=getStr(s);
        PKoo[high(Pkoo)].Bem:=getStr(s);
      end;
    end;
    closefile(f);
  end;
end;

function GetPolar(s:string;var RI,DI,ZD,RF:Double;var NR,Code,Bem:String):TSatztyp;
begin
  RI:=0;DI:=0;ZD:=0;NR:='';Code:='';bem:='';
  if copy(s,1,1)='*' then
  begin
    Result:=Kommentar;
    Exit;
  end;
  if copy(S,1,1)='-' then
  begin
    Result:=Standpunkt;
    Nr:=getstr(s);
    delete(Nr,1,1);
    RF:=getfloat(s);
    Exit;
  end;
  nr:=Getstr(s);
  RI:=getFloat(s);
  Di:=getFloat(s);
  Zd:=getFloat(s);
  Code:=getStr(s);
  bem:=getStr(s);
  if ZD>200 then
  begin
    ZD:=400-ZD;
    RI:=RI-200;
    if RI<0 then RI:=RI+400;
  end;
  Result:=Zielpunkt;
end;

Function Kugelmittelpunkt(var P:Array of TPunkt;R:Double;PolarKoo:Boolean):Integer;
Type
  TVektor=Array of Double;
  T3Vektor=Array[1..3] of Double;
  TMatrix=Array of Array of Double;
var
  v1,v2,v3,X0,dx:T3Vektor;
  L,M,sv:TVektor;
  A,N,B:TMatrix;
  i,j,k,ia,ib,ic,iter:integer;
  sum,sumx,sumy,S,T,S0,T0,h:Double;


function Inverse(var S:TMatrix;U:Integer):boolean;
var j,k,l:Integer;
begin
  Inverse:=True;
  (* Invertieren *)
  for j:=1 to U do
  begin
    If abs(S[j,j])<1E-32 then
    begin
      Inverse:=False;
      Exit;
    end;
    S[j,j]:=1/S[j,j];
    for l:=1 to U do
      if l<>j then
      begin
        S[l,j]:=-S[j,j]*S[l,j];
        for k:=1 to U do
        if k<>J then S[l,k]:=S[l,j]*S[j,k]+S[l,k];
      end;
    for k:=1 to U do
      If k<>J then S[j,k]:=S[j,j]*S[j,k];
  end;
end;

Procedure Kugelaus4Punkten(var P:Array of TPunkt;var XM,YM,ZM,R:Double);
var
  X,L:TVektor;
  A:TMatrix;
  i,j:integer;
begin
  R:=0;XM:=0;YM:=0;ZM:=0;
  If High(P)<4 then exit;
  setlength(A,5,5);
  setlength(L,5);
  setlength(X,5);

  for i:=1 to 4 do
  begin
    A[i,1]:=1;
    A[i,2]:=P[i].X-P[1].X;
    A[i,3]:=P[i].Y-P[1].Y;
    A[i,4]:=P[i].Z-P[1].Z;
    L[i]:=(sqr(P[i].X-P[1].X)+sqr(P[i].Y-P[1].Y)+sqr(P[i].Z-P[1].Z));
  end;
  if not Inverse(A,4) then exit;
  For i:=1 to 4 do X[i]:=0;
  For i:=1 to 4 do
    For j:=1 to 4 do X[i]:=X[i]+A[i,j]*L[j];
  XM:=X[2]/2;YM:=X[3]/2;ZM:=X[4]/2;
  R:=SQRT(XM*XM+YM*YM+ZM*ZM-X[1]);
  XM:=XM+P[1].X;YM:=YM+P[1].Y;ZM:=ZM+P[1].Z;
end;

begin
  //Arrays Initialisieren
  Result:=-1;
  if High(P)<3 then exit;
  setlength(A,High(P)+1,4);
  Setlength(L,High(P)+1);
  Setlength(M,High(P)+1);
  Setlength(N,4,4);
  FillChar(X0,SizeOf(X0),0);
  P[0].X:=0;P[0].Y:=0;P[0].Z:=0;
  If PolarKoo then
  begin
    for i:=1 to high(P) do
    begin
      S:=p[i].X;
      T:=P[i].Y;
      P[i].X:=S*cos(T/RHOG);
      P[i].Y:=S*sin(T/RHOG);
    end;
  end;
  // suche nach flchengrssten Dreieck , lngste Grundlinie
  sum:=0;ia:=0;ib:=0;
  for i:=1 to high(P) do
    for j:=i+1 to high(P) do
    begin
      S0:=sqr(P[j].X-P[i].X)+sqr(P[j].Y-P[i].Y);
      if S0>sum then
      begin
        sum:=S0;
        ia:=i;ib:=j;
      end;
    end;
  sum:=0;ic:=0;
  RIWI(P[ib].Y-P[ia].Y,P[ib].x-P[ia].X,S0,T0);
  //  Suche grsste Dreieckshhe ber Grundlinie
  for i:=1 to high(P) do
  begin
    RIWI(P[i].Y-P[ia].Y,P[i].X-P[ia].x,S,T);
    h:=abs(S*sin(T-T0));
    if (h>sum) and (i<>ib)  then
    begin
      sum:=h;ic:=i;
    end;
  end;
  if ic=0 then
  begin
    result:=-2;
    exit;
  end;
  RIWI(P[ic].Y-P[ia].Y,P[ic].X-P[ia].x,S,T);

  // Umkreismittelpunkt im Dreieck abc berechnen
  v1[1]:=P[ib].X-P[ia].X;
  v1[2]:=P[ib].Y-P[ia].Y;
  v1[3]:=P[ib].Z-P[ia].Z;

  v2[1]:=P[ic].X-P[ia].X;
  v2[2]:=P[ic].Y-P[ia].Y;
  v2[3]:=P[ic].Z-P[ia].Z;
  // Nomalenvektor Kreuzprodukt v1xv2
  v3[1]:=v1[2]*v2[3]-v1[3]*v2[2];
  v3[2]:=v1[3]*v2[1]-v1[1]*v2[3];
  v3[3]:=v1[1]*v2[2]-v1[2]*v2[1];
  sum:=0;
  for i:=1 to 3 do sum:=sum+v3[i]*v3[i];
  sum:=Sqrt(sum);
  if (sum<=0) or (R=0)  then
  begin
    Result:=-3;
    Exit;
  end;

  for i:=1 to 3 do v3[i]:=v3[i]/Sum;
  A[1,1]:=2*(P[ib].X-P[ia].X);A[1,2]:=2*(P[ib].Y-P[ia].Y);
  A[2,1]:=2*(P[ic].X-P[ia].X);A[2,2]:=2*(P[ic].Y-P[ia].Y);
  if not Inverse(A,2) then
  begin
    Result:=-4;
    exit;
  end;

  L[1]:=sqr(P[ib].X)-sqr(P[ia].X)+sqr(P[ib].Y)-sqr(P[ia].Y);
  L[2]:=sqr(P[ic].X)-sqr(P[ia].X)+sqr(P[ic].Y)-sqr(P[ia].Y);
  for i:=1 to 2 do
  begin
    x0[i]:=0;
    for j:=1 to 2 do x0[i]:=x0[i]+A[i,j]*L[j];
  end;
  // Abstand Umkreismittelpunkt Kugelmittelunkt
  sum:=(R*R-sqr(x0[1]-P[ia].X)-sqr(x0[2]-P[ia].Y));
  if sum<=0 then
  begin
    Result:=-5;
    exit
  end
  else sum:=sqrt(sum);

  x0[3]:=(P[ia].Z+P[ib].Z+P[ic].Z)/3;
  // Kugelmittelpunkt berechnen
  if v3[3]<0 then sum:=-sum;

  for i:=1 to 3 do x0[i]:=x0[i]-sum*v3[i];
  Form1.Memo1.Lines.Add('');
  Form1.Memo1.lines.add('Kugelzentrierung Punkt '+P[0].PKtNR);
  Form1.Memo1.Lines.Add(
   format('3 Punkt Umkreis Lsung     XM=%10.3f YM=%10.3f ZM=%10.3f R %5.3f',[X0[1],X0[2],X0[3],R]));
  if High(P)>3 then
  begin
    Kugelaus4Punkten(P,X0[1],X0[2],X0[3],sum);
    Form1.Memo1.Lines.Add(
    format('Analytische 4 Punkt Lsung XM=%10.3f YM=%10.3f ZM=%10.3f R %5.3f',[X0[1],X0[2],X0[3],sum]));
  end;
  // Ausgleichung Arrays Nullsetzen
  for i:=0 to High(P) do
  begin
    L[i]:=0;
    for j:=0 to 3 do  A[i,j]:=0;
  end;
  for i:=0 to 3 do
  begin
    M[i]:=0;
    for j:=0 to 3 do N[i,j]:=0;
  end;
  Iter:=0;
  //repeat
  // Fehlergleichungen aufstellen
  for i:=1 to High(P) do
  begin
    A[i,1]:=(x0[1]-P[i].X)/R;A[i,2]:=(X0[2]-P[i].Y)/R;A[i,3]:=(X0[3]-P[i].z)/R;
    L[i]:=sqrt(sqr(x0[1]-P[i].X)+sqr(X0[2]-P[i].Y)+sqr(X0[3]-P[i].Z))-R;
  end;
{
for i:=1 to High(P) do
     for j:=1 to 3 do
     form1.memo1.Lines.add(
      Format('A[%d,%d]=%10.6f',[i,j,A[i,j]]));
for i:=1 to High(P) do
   form1.memo1.Lines.add(
      Format('L[%d]=%10.6f',[i,L[i]]));
}
  // Normalgleichungen
  for i:=1 to 3 do
    for j:=1 to 3 do
      for k:=1 to High(P) do N[i,j]:=N[i,j]+A[k,i]*A[k,j];
{
  for i:=1 to 3 do
     for j:=i to 3 do form1.memo1.Lines.add(
      Format('N[%d,%d]=%10.6f',[i,j,N[i,j]]));

}
  If not Inverse(N,3) then
  begin
   Result:=-6;
   Exit;
  end;
  for i:=1 to 3 do
    for j:=1 to High(P) do M[i]:=M[i]+A[j,i]*L[j];
  // Unbekanntenvektor
  FillChar(dx,Sizeof(dx),0);
  for i:=1 to 3 do
    for j:=1 to 3 do dx[i]:=dx[i]+N[i,j]*M[j];
  // Mittelpunktkorrektur
  for i:=1 to 3 do x0[i]:=x0[i]-dx[i];
  // Fehlerrrechnung
  sum:=0;
  for i:=1 to High(P) do
  begin
    P[i].V:=sqrt(sqr(x0[1]-P[i].X)+sqr(X0[2]-P[i].Y)+sqr(X0[3]-P[i].Z))-R;
    sum:=sum+sqr(P[i].v);
  end;
  // m0
  if High(P)>3 then sum:=sqrt(sum/(high(P)-3)) else sum:=0;
  //m dx
  For i:=1 to 3 do v1[i]:=sum*sqrt(N[i,i]);

  // Result setzen
  P[0].X:=X0[1];
  P[0].Y:=X0[2];
  P[0].Z:=X0[3];
  Result:=0;
  // Qvv berechnen
  setlength(Sv,High(P)+1);
  for i:=1 to high(P) do
  begin
    sv[i]:=0;
    for j:=1 to 3 do
      for k:=1 to 3 do
        sv[i]:=sv[i]+A[i,k]*N[j,k]*A[i,j];
  end;
  // NV berechnen
  for i:=1 to high(P) do  if sum>0 then sv[i]:=P[i].v/(sum*sqrt(sv[i])) else sv[i]:=0;

  inc(iter);
  Form1.Memo1.Lines.Add(format('Ausgleichung %16s',[P[0].PktNr]));
{
  for i:=1 to 3 do
     for j:=i to 3 do form1.memo1.Lines.add(
     format('N[%d,%d]=%10.6f',[i,j,N[i,j]]));
}
  Form1.Memo1.Lines.add(Format('X0=%10.4f Y0=%10.4f Z0=%10.4f',[X0[1]-dx[1],X0[2]-dx[2],X0[3]-dx[3]]));
  Form1.Memo1.Lines.Add(
    format('dx=%10.4f dy=%10.4f dZ=%10.4f',[dx[1],dx[2],dx[3]]));
  Form1.Memo1.Lines.Add(
  format('XM=%10.4f YM=%10.4f ZM=%10.4f',[X0[1],X0[2],X0[3]]));
  if sum>0 then
  begin
    Form1.Memo1.Lines.Add(format('m0=%10.4f',[sum]));
    Form1.Memo1.Lines.Add(
    format('mXM=%9.4f mYM=%9.4f mZM=%9.4f',[v1[1],v1[2],v1[3]]));
  end;
  for i:=1 to high(P) do
  if sum>0 then Form1.Memo1.Lines.Add(format('%-16s vR %7.4f NV %4.1f',[P[i].PktNr,P[i].v,sv[i]]))
  else Form1.Memo1.Lines.Add(format('%-16s vR %7.4f',[P[i].PktNr,P[i].v]));

  //until (abs(dx[1])+ abs(dx[2])+ abs(dx[3])<5E-3) or (iter=10);
  if Polarkoo then
  begin
    for i:=0 to high(P) do
    begin
      RIWI(P[i].Y,P[i].X,S,T);
      P[i].X:=S;P[i].Y:=T*RhoG;
      P[i].Z:=arctan((P[i].Z)/S)*RhoG;
    end;
  end;
end;



procedure TForm1.ToolButtonRechneClick(Sender: TObject);
var
    i,ia,ie,j,i1,i2,Anzahl:Integer;
    PktDoppelt:Array of Boolean;
    S,Satz,code,Bem,PS,PZ,Nr:String;
    RI,DI,ZD,RF,ST,ORI,MF,HF,S0,T0,YM,XM,ZM,R0,fS:Double;
    Satztyp:TSatzTyp;
    MerkPKoo:Array of Integer;
function GetPNR(i:Integer):String;
var
  j:integer;
begin
  j:=Pos(' ',SL.Strings[i]);
  if j>0 then Result:=copy(SL.Strings[i],1,j-1)
  else Result:='';
end;

begin
  Form1.Memo1.Lines.Clear;
  SL:=TStringList.Create;
  SL.LoadFromFile(EditEindat.Text);
  setlength(PktDoppelt,SL.Count+1);
  for i:=0 to SL.Count-1 do SL.Strings[i]:=trim(SL.Strings[i]);
  LiesKoordDat(EditKoordat.text);
  RichEditMessdat.clear;
  RichEditmessdat.Lines.LoadFromFile(EditEindat.text);

  i:=0;
  setlength(MerkPKOO,0);
  RF:=0;MF:=1;ORI:=0;HF:=0;i1:=0;Anzahl:=0;i2:=0;fS:=0;R0:=0;
  repeat
    SatzTyp:=GetPolar(SL.strings[i],RI,DI,ZD,RF,NR,Code,bem);
    if length(PKoo)>0 then
    begin
      case satztyp of
      Standpunkt:
      begin
        PS:=Nr;HF:=RF;
        MF:=0;Ori:=0;PZ:='';
        i1:=0;
        while (i1<high(Pkoo)) and (PS<>PKoo[i1].NR) do inc(i1);
      end;
      Zielpunkt:
      If PZ='' then
      begin
        PZ:=NR;
        i2:=0;
        while (i2<high(Pkoo)) and (PZ<>PKoo[i2].NR) do inc(i2);
        if PZ=PKoo[i2].NR then
        begin
          RIWI(PKoo[i2].Y-PKoo[i1].Y,Pkoo[i2].X-PKoo[i1].X,S0,T0);
          ORI:=T0-RI/RhoG;
          R0:=Ri;
          fS:=s0-sin(ZD/RhoG)*DI;
          MF:=sin(ZD/RhoG)*DI/S0;
        end;
      end;
      Kommentar:;
    end;
    end;
    If (GetPNR(i) = GetPNR(i+1)) and (GetPNR(i)=GetPNR(i+2)) then
    begin
      ia:=i;ie:=ia+2;
      While (ie<SL.Count-1) and (getPNR(ie)=getPNR(ie+1)) do inc(ie);
      setlength(P,0);
      setlength(P,ie-ia+2);
      for j:=ia to ie do
      begin
        Satz:=SL.Strings[j];
        P[j-ia+1].PktNR:=Getstr(Satz);
        Ri:=GetFloat(satz);
        DI:=GetFloat(satz);
        ZD:=GetFloat(satz);
        RF:=GetFloat(satz);

        P[j-ia+1].Y:=sin(RI/RhoG)*DI*sin(ZD/RhoG);
        P[j-ia+1].X:=cos(Ri/RhoG)*DI*sin(ZD/RhoG);
        P[j-ia+1].Z:=DI*cos(ZD/RHOG);
        P[j-ia+1].v:=0;
      end;
      P[0].PktNR:=P[1].PKtNR;
      If Kugelmittelpunkt(P,RF,False) >0 then Showmessage('Kugelmittelnpunkt Fehler')
      else
      begin
        inc(anzahl);
        StatusBar1.SimpleText:=format('%d Punkte zenrtiert',[Anzahl]);
        for j:=ia to ie do SL.strings[j]:='*'+SL.Strings[j];
        DI:=Sqrt(sqr(P[0].X)+sqr(P[0].Y)+sqr(P[0].Z));
        RIWI(P[0].Y,P[0].X,ST,RI);
        RI:=RI*RhoG;
        ZD:=100-Arctan(P[0].Z/ST)*RhoG;
        satz:=SL.Strings[ia];
        getstr(satz);getStr(Satz);getStr(satz);getStr(satz);GetStr(satz);
        s:=format('%-16s %10.4f %10.3f %10.4f 0.00 %s',[P[0].PktNR,RI,DI,ZD,Satz]);
        SL.Insert(ia,s);
        s:=format('%-16s RI%10.4f DI%10.3f ZD%10.4f RF 0.00 %s',[P[0].PktNR,RI,DI,ZD,Satz]);
        RichEditMessdat.lines.Insert(ia,s);
        markiere(RichEditMessdat,s,clred,[fsBold]);
        Memo1.lines.add('Polarkoordinaten des Kugelmittelpunktes');
        Memo1.lines.add(s);
        if length(Pkoo)>0 then
        begin
          memo1.lines.add('Kugelmittelpunkt polar anhngen');
          memo1.Lines.add(format('PS %-16s Y %12.3f X %12.3f Z %10.3f iH %6.3f',[Pkoo[i1].NR,Pkoo[i1].Y,Pkoo[i1].X,Pkoo[i1].Z,HF]));
          memo1.Lines.add(format('PF %-16s Y %12.3f X %12.3f Z %10.3f',[Pkoo[i2].NR,Pkoo[i2].Y,Pkoo[i2].X,Pkoo[i2].Z]));
          memo1.lines.add(format('r0%10.4f o%10.4f S%10.4f fS%10.4f dM%10.2f ppm',[R0,Ori*RhoG,S0+fS,fS,(MF-1)*1E6]));
          YM:=PKoo[i1].Y+sin(ORI+Ri/RhoG)*sin(zd/RhoG)*DI*MF;
          XM:=PKoo[i1].X+Cos(ORI+Ri/RhoG)*sin(zd/RhoG)*DI*MF;
          ZM:=PKoo[i1].Z+HF+Sin(zd/RhoG)*DI*MF/Tan(ZD/RhoG);
          Memo1.lines.Add('Koordinaten des Kugelmittelpunktes');
          s:=format('%-16s Y %12.3f X %12.3f Z %10.3f %s',[P[0].PktNR,YM,XM,ZM,Satz]);
          Memo1.Lines.Add(s);
          j:=0;
          while (j<High(Pkoo)) and (P[0].pktNR<>PKOo[j].NR) do inc(j);
          if PKoo[j].NR<>P[0].PktNr then
          begin
            setlength(PKOO,length(PKoo)+1);
            j:=high(Pkoo);
            PKoo[j].NR:=P[0].PktNr;
            PKoo[j].Code:=getstr(Satz);
            PKoo[j].Bem:=satz;
          end;
          Pkoo[j].Y:=YM;
          PKoo[j].X:=XM;
          PKoo[j].Z:=ZM;
          setlength(MerkPKoo,length(MerkPKoo)+1);
          MerkPKoo[high(MerkPKOO)]:=j;
        end;
      end;
      i:=ie;
    end;
    inc(i);
  until i>=SL.Count-3;
  if FileExists(EditAusdat.Text) then
  begin
    if messagedlg('Beobachtungsdatei berschreiben',mtconfirmation,[mbYES,mbNo],0)=mrYes then
      SL.SaveToFile(EditAusdat.text);
  end
  else
      SL.SaveToFile(EditAusdat.text);

  S:=copy(Form1.EditAusdat.Text,1,length(form1.EditAusdat.Text)-3);
  Memo1.Lines.SaveToFile(S+'LST');

//  RichEditMessdat.clear;
//  RichEditmessdat.Lines.LoadFromFile(EditAusdat.text);

  // Koordinaten anzeigen
  RichEditKoo.Clear;
  RichEditKoo.Lines.add('*Punktnummer         Rechts         Hoch          Hhe   Code Bemerkung');
  for i:=0 to High(PKOO) do
  begin
    s:=format('%16s  %12.3f  %12.3f  %10.3f %s %s',[PKOO[i].NR,PKOO[i].Y,PKoo[i].X,PKoo[i].Z,PKoo[i].Code,PKoo[i].Bem]);
    RichEditKoo.Lines.add(s);
  end;
  // Zentrierte Punkte kennzeichnen
  for i:=0 to high(MerkPKoo) do
    MarkiereZeile(RichEditKoo,MerkPKoo[i]+1,clRed,[fsBold]);

  if FileExists(EditKoordat.Text) then
  begin
    if messagedlg('Koordinatendatei berschreiben',mtconfirmation,[mbYES,mbNo],0)=mrYes then
    begin
      RichEditKoo.Lines.SaveToFile(EditKoordat.text);
    end;
  end
  else
    If EditKoorDat.text<>'' then
    begin
      RichEditKoo.Lines.SaveToFile(EditKoordat.text);
    end;

  SL.Free;
  setlength(PKoo,0);
end;


procedure TForm1.ToolButtonEndeClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.ToolButtonHelpClick(Sender: TObject);
begin
  FormHelp.ShowModal;
end;


procedure TForm1.EditEindatDblClick(Sender: TObject);
begin
  Opendialog1.Filter:='Messdaten|*.DAT';
  If Opendialog1.execute then
  begin
    EditEindat.Text:=Opendialog1.FileName;
    EditAusdat.text:=EditEindat.Text;
  end;
end;

procedure TForm1.EditKoorDatDblClick(Sender: TObject);
begin
  Opendialog1.Filter:='Koordianten|*.KOR';
  If Opendialog1.execute then
  begin
    EditKoordat.Text:=Opendialog1.FileName;
  end;
end;



procedure TForm1.FormActivate(Sender: TObject);
begin
  FormatSettings.DecimalSeparator:='.';
  FormatSettings.ThousandSeparator:=#0;
  FormatSettings.DateSeparator:='.';
  FormatSettings.ShortDateFormat:='dd.mm.yyyy';
  Form1.Caption:='Kugelzentrierung Ver '+GetVersionInfos(Application.Exename);
  PageControl1.TabIndex:=0;
end;

procedure TForm1.Einfgen1Click(Sender: TObject);
begin
  Editor.PasteFromClipboard;
end;

procedure TForm1.Rckgngig1Click(Sender: TObject);
begin
  Editor.Undo;
end;

procedure TForm1.Lschen1Click(Sender: TObject);
begin
  Editor.ClearSelection;
end;

procedure TForm1.Allemarkieren1Click(Sender: TObject);
begin
  Editor.SelectAll
end;

procedure TForm1.Ausschneiden1Click(Sender: TObject);
begin
  Editor.CopyToClipboard;
end;

procedure TForm1.Ausschneiden2Click(Sender: TObject);
begin
  Editor.CutToClipboard;
end;

end.
